function data()
	--print("commonapiLoaderInFileSystem");
local function getMyPath()
	local mypath = debug.getinfo(1, "S").source:sub(2)
	mypath = string.gsub(mypath, '\\', '/')
	mypath = string.gsub(mypath, "/filesystem%.lua$", "/")
	return mypath
end

local function commonapiLoaderInFileSystem()
	local mypath = getMyPath()
	local oldpackagepath = package.path
	package.path = mypath.."res/scripts/?.lua;"..oldpackagepath

	local luafn, err = loadfile(mypath.."strings.lua", "bt")

	local ok, err = pcall(luafn)

	if (ok ~= nil) then
		data()
	else
		print("commonapiLoaderInFileSystem can't load strings.lua");
		print(err)
	end
end

--commonapiLoaderInFileSystem()

--commonapi.dmp(debug.getregistry(), {process = commonapi.utils.dmphide, metatable = 2})

local function resetFileSyncSystem()
	local mypath = getMyPath()
	if (mypath ~= nil) then
		local repos = {
			"repository_track", "repository_street", "repository_bridge", "repository_tunnel", "repository_railroadCrossing", "loaderrors"
		}
		for _, key in pairs(repos) do
			local fullfilename = mypath.."syncobject-"..key
			print("commonapi2.filesystem.lua: resetFileSyncSystem", fullfilename)
			local file, fileerr = io.open(fullfilename, "w");
			if (file ~= nil) then
				file:write("")
				file:close()
			else
				print(fileerr)
			end
		end
	end
end

resetFileSyncSystem()


return {
	hiddenDirs = {},
	hiddenFiles = {}
}
end