function data()
local buildNr = 20240303

return {
	info = {
		minorVersion = 8,
		build = buildNr,
		severityAdd = "NONE",
		severityRemove = "WARNING",
		name = _("eis_os_commonapi2").. " - "..buildNr,
		description = _("eis_os_commonapi2_desc"),
		authors = {
			{
			  name = "eis_os",
			  role = "CREATOR",
			  text = "",
			}
		},
		tags = {"Script Mod"},
		modid = "eis_os_commonapi2_1",
	},
	runFn = function (settings, modParams)
		if (commonapi ~= nil) then
			commonapi.repos._prepSettings(settings)
			commonapi.repos._addModifer()
			if (commonapi._info.settings.checkmods ~= nil and commonapi._info.settings.checkmods == true) then
				local checkModels = require("commonapi2.fix.checkModels")
				checkModels._addModifer()
			end
		end
	end,

	postRunFn = function (settings, modParams)
		if (commonapi ~= nil) then
			if (commonapi._native ~= nil and commonapi._native.renameLuaState ~= nil) then
				commonapi._native.renameLuaState("postRunFn Thread")
			end
		end
	end,

	settings = {
		-- see loadSettingsDefaults
		uiscale = {
			type = "number",
			name = _("setting_uiscale"),
			description = _("setting_uiscale_desc"),
			default = 1,
			max = 3.0,
			order = 2,
		},

		improveui = {
			type = "number",
			name = _("setting_improveui"),
			subtype = "integer",
			default = 1,
			description = _("setting_improveui_desc"),
			order = 5,
			min = 0,
			max = 1,
		},

		flexstreets = {
			type = "boolean",
			name = _("setting_flexstreets"),
			description = _("setting_flexstreets_desc"),
			default = true,
			order = 7,
		},

		flexstreetstracks = {
			type = "boolean",
			name = _("setting_flexstreetstracks"),
			description = _("setting_flexstreetstracks_desc"),
			default = false,
			order = 8,
		},

		linedestination = {
			type = "boolean",
			name = _("setting_enablelinedestination"),
			description = _("setting_enablelinedestination_desc"),
			default = true,
			order = 10,
		},

		newevents = {
			type = "boolean",
			name = _("setting_enablenewevents"),
			description = _("setting_enablenewevents_desc"),
			default = false,
			order = 11,
		},

		lineevents = {
			type = "boolean",
			name = _("setting_enablelineevents"),
			description = _("setting_enablelineevents_desc"),
			default = false,
			order = 12,
		},

		simperson = {
			type = "boolean",
			name = _("setting_simperson"),
			description = _("setting_simperson_desc"),
			default = false,
			order = 13,
		},

		layerview = {
			type = "number",
			subtype = "integer",
			min = 0,
			max = 2,
			name = _("setting_layerview"),
			description = _("setting_layerview_desc"),
			default = 0,
			order = 14,
		},

		fixscripts = {
			type = "boolean",
			name = _("setting_fixscripts"),
			description = _("setting_fixscripts_desc"),
			default = true,
			order = 15,
		},

		checkmods = {
			type = "boolean",
			name = _("setting_checkmods"),
			description = _("setting_checkmods_desc"),
			default = false,
			order = 19,
		},

		fastsave = {
			type = "boolean",
			name = _("setting_fastsave"),
			default = true,
			description = _("setting_fastsave_desc"),
			order = 100,
		},

		fastdebugmode = {
			type = "boolean",
			name = _("setting_fastdebugmode"),
			default = false,
			description = _("setting_fastdebugmode_desc"),
			order = 101,
		},

		verbosity = {
			type = "number",
			subtype = "integer",
			name = _("setting_verbosity"),
			description = _("setting_verbosity_desc"),
			default = 0,
			min = 0,
			max = 99,
			order = 99,
		},

		enableluasocket = {
			type = "boolean",
			name = _("setting_enableluasocket"),
			default = false,
			description = _("setting_enableluasocket_desc"),
			order = 201,
		},

		location7zip = {
			type = "string",
			default = "",
			name = _("setting_location7zip"),
			description = _("setting_location7zip_desc"),
			order = 250,
		},

		disablenative = {
			type = "boolean",
			name = _("setting_disablenative"),
			description = _("setting_disablenative_desc"),
			order = 300,
		},

		rendermode = {
			type = "number",
			subtype = "integer",
			default = 1,
			name = _("setting_rendermode"),
			description = _("setting_rendermode_desc"),
			order = 301,
		},

		workshopbackup = {
			type = "string",
			default = "",
			name = _("setting_workshopbackup"),
			description = _("setting_workshopbackup_desc"),
			order = 302,
		},

		buildoverwrite = {
			type = "string",
			default = "",
			name = _("setting_buildoverwrite"),
			description = _("setting_buildoverwrite_desc"),
			order = 330,
		},

	},
}
end