require "tableutil"
local ssu = require "stylesheetutil"

local hp = 10
local vp = 5
local defaultMargin = hp

local constructionMenuMainColor = ssu.makeColor(5+25, 25+25, 40+25, 200)
local constructionMenuBackColor = ssu.makeColor(5, 25, 40, 210)
local constructionMenuHoverColor = ssu.makeColor(5+10, 25+10, 40+10, 200)

function data()
	local result = { }

	local a = ssu.makeAdder(result)

	result.animations = { }
	a("!linestop-linedestinationOld", {
		borderColor = ssu.makeColor(255, 255, 255),
		borderWidth = { 0, 3, 0, 0 },
		backgroundColor2 = ssu.makeColor(255, 255, 255, 100),
		backgroundImage2 = {
			fileName = "ui/icons/warnings/station.tga",
			--horizontal = {0, 1, 1, 16},
			--vertical = {0, 1, 1, 16},
			--horizontal = {0, 20, 130, 150},
			--vertical = {0, 19, 21, 40}
		},
	})
	a("LineDestIndicators", {
		--margin = { 0, 20, 0, 0 },
	})

	a("!linestop-linedestination", {
		size = { 19, 19 },
		backgroundColor1 = ssu.makeColor(255, 255, 255, 100),
		backgroundImage1 = {
			fileName = "ui/icons/warnings/station.tga",
		},
	})

	a("!linestop-vehiclearrived-script", {
		size = { 19, 19 },
		backgroundColor2 = ssu.makeColor(255, 0, 0, 255),
		backgroundImage2 = {
			fileName = "ui/icons/game-menu/play@2x.tga",
		},
	})

	a("!linestop-vehiclenextstop-returnto LineDestIndicators2", {
		size = { 19, 19 },
		backgroundColor1 = ssu.makeColor(255, 255, 255, 255),
		backgroundImage1 = {
			fileName = "ui/icons/windows/vehicle_reverse@2x.tga",
		},
	})

	a("!linestop-vehiclenextstop-script LineDestIndicators2", {
		size = { 19, 19 },
		backgroundColor2 = ssu.makeColor(0, 255, 0, 125),
		backgroundImage2 = {
			fileName = "ui/icons/game-menu/play@2x.tga",
		},
	})

	--[[
	a("#mainMenuLeft.CommonAPI2Button.button.icon", {
		color = ssu.makeColor(255, 255, 255),
		backgroundImage1 = { fileName = "ui/design/buttons/disk_small_behind.tga" },
		backgroundImage2 = { fileName = "ui/design/buttons/disk_small_surface.tga" },
		borderImage = { fileName = "ui/design/buttons/disk_small_contour.tga" },
		backgroundColor1 = ssu.makeColor(15, 35, 50, 90),
		backgroundColor2 = ssu.makeColor(15, 35, 50),
		borderColor = ssu.makeColor(255, 255, 255, 128)
	})
	a("#mainMenuLeft.CommonAPI2Button.button.icon:hover", {
		backgroundColor1 = ssu.makeColor(183, 188, 193, 128),
		borderColor = ssu.makeColor(255, 255, 255)
	})
	a("#mainMenuLeft.CommonAPI2Button.button.icon:active", {
		backgroundColor1 = ssu.makeColor(15, 35, 50, 90),
		backgroundColor2 = ssu.makeColor(110, 122, 132)
	})
	a("#mainMenuLeft.CommonAPI2Button.button.icon:disabled", {
		color = ssu.makeColor(128, 128, 128)
	}) --]]


	a("!commonapi-layerview-off ImageView", {
		backgroundColor = ssu.makeColor(200, 0, 0, 70)
	})

	a("!commonapi-layerview-on ImageView", {
		backgroundColor = ssu.makeColor(0, 200, 0, 70)
	})

	a("commonapi-ConlistButton", {
		maxSize = { 200, 110 },
		minSize = { 0, 75 },
	})

	a("commonapi-ConlistButton !con-entry-icon, commonapi-ConListPopup !con-entry-icon", {
		color = ssu.makeColor(255, 255, 255),
		padding = { 2, 10, 2, 10 },
		borderWidth = { 2, 2, 2, 2 },
		borderColor = ssu.makeColor(214, 214, 214, 0),
		maxSize = { 200, 75 },
		minSize = { 0, 75 },
	})

	a("commonapi-ConlistButton !con-entry-submenu", {
		maxSize = { 150, 20 },
		size = { 150, 20 },
	})

	a("commonapi-ConlistButton !con-entry-single", {
		padding = { 20, 10, 2, 10 },
	})

	a("commonapi-ConListPopup !con-entry-single", {
		padding = { 5, 10, 5, 10 },
	})

	a("commonapi-ConlistButton !con-entry-icon:hover, commonapi-ConListPopup !con-entry-icon:hover", {
		backgroundColor = ssu.makeColor(255, 255, 255, 30),
		borderColor = ssu.makeColor(255, 255, 255, 30)
	})
	a("commonapi-ConlistButton !con-entry-icon:active, commonapi-ConListPopup !con-entry-icon:active", {
		backgroundColor = ssu.makeColor(255, 255, 255, 30),
		borderColor = ssu.makeColor(255, 255, 255, 100),
	})
	a("commonapi-ConlistButton !con-entry-icon:disabled, commonapi-ConListPopup !con-entry-icon:disabled", {
		color = ssu.makeColor(150, 150, 150)
	})

	a("!commonapi-cathighlight", {
		borderWidth = { 2, 2, 2, 2 },
		borderColor = ssu.makeColor(214, 214, 214, 100),
	})

	a("!commonapi-catnohighlight", {
		borderWidth = { 2, 2, 2, 2 },
		borderColor = ssu.makeColor(214, 214, 214, 0),
	})

	a("#LineDestinationInfo", {
		textAutoWrap = true,
		--borderColor = ssu.makeColor(214, 214, 214, 100),
		--borderWidth = { 2, 2, 2, 2 },
		padding = { 0, 0, 0, 0 },
	})

	a("!commonapi-script", {
		fontFamily = "Noto/NotoSansMono-Regular.ttf"
	})

	a("!scripthelp-name", {
		fontSize = 16,
		fontFamily = "Noto/NotoSansMono-Regular.ttf",
		padding = { 0, 0, 0, 10 },
		margin = { 10, 0, 0, 0 },
	})

	a("!scripthelp-params", {
		padding = { 0, 0, 0, 30 },
		margin = { 0, 0, 0, 0 },
	})

	a("!scripthelp-desc", {
		padding = { 0, 10, 0, 40 },
		margin = { 0, 0, 0, 0 },
	})

	a("#LineDestinationTextScrollArea", {
		padding = { 0, 0, 0, 20 },
		maxSize = { 150, -1 }
	})

	a("#LineDestinationText", {
		minSize = { 120, -1 },
		size = { -1, -1 },	-- Hack 27 as in line-manager.lua
	})

	a("!commonapi-nodeeditor-colorpadding", {
		borderColor = { 0.0, 0.0, 0.0, 0.0 },
		borderWidth = { 0, 0, 0, 20 },
	})
	a("!commonapi-nodeeditor-blue", {
		borderColor = { 0.0, 0.0, 0.7, 1.0 },
		borderWidth = { 0, 0, 0, 20 },
	})
	a("!commonapi-nodeeditor-yellow", {
		borderColor ={ 1.0, 1.0, 0.0, 1.0 },
		borderWidth = { 0, 0, 0, 20 },
	})
	a("!commonapi-nodeeditor-red", {
		borderColor = { 0.7, 0.0, 0.0, 1.0 },
		borderWidth = { 0, 0, 0, 20 },
	})
	a("!commonapi-nodeeditor-green", {
		borderColor ={ 0.0, 0.7, 0.0, 1.0 },
		borderWidth = { 0, 0, 0, 20 },
	})

	return result
end
