local vs = {}
vs._doc = {}
vs.testmode = false
local _utils = commonapi.utils

local hs = commonapi.rerequire("commonapi2.lineextradetails.helperscript")
local conobj = commonapi.rerequire("commonapi2.lineextradetails.constructionscript")
-- vs = require("commonapi2.lineextradetails.vehiclescript")
-- vs = commonapi.rerequire("commonapi2.lineextradetails.vehiclescript")
-- x = vs.reload(34466)
-- x:add(3418)
-- x:doIt()
--
-- x:add("train/eurodual_v2.mdl")
-- x:add("ship/herkules_xi_tanker_v3.mdl")
--[[
vs = commonapi.rerequire("commonapi2.lineextradetails.vehiclescript")
vs.run(34466, "vs:createModel(\"train/eurodual_v2.mdl\"):insertAt(-1):doIt()")
tv = api.engine.getComponent(34466, api.type.ComponentType.TRANSPORT_VEHICLE)
tvv = tv.transportVehicleConfig.vehicles
commonapi.dmp(vs.deepcopy(tvv))
--]]

--[[
vs = commonapi.rerequire("commonapi2.lineextradetails.vehiclescript")
vs.run(96241, "vs:add(\"train/eurodual_v2.mdl\") vs:doit() ")

x = vs.reload(96241)
e = x:selectEngines() r = e:remove() r:setColor({1, 0.5, 1}) r:insertAt(-1)

tv = api.engine.getComponent(96241, api.type.ComponentType.TRANSPORT_VEHICLE)
tvv = tv.transportVehicleConfig.vehicles
commonapi.dmp(vs.deepcopy(tvv))
--]]

--[[
vs:createModel("train/eurodual_v2.mdl"):insertAt(-1):doIt()

vs = commonapi.rerequire("commonapi2.lineextradetails.vehiclescript")
vs.run(-1, "conobj.new(22913):setParameter(\"lmp_t174_Farbe_FZ\", 1):doIt()")


vs:createModel("train/eurodual_v2.mdl"):insertAt(-1):doIt()



vsobj = commonapi.rerequire("commonapi2.lineextradetails.vehiclescript")
vsobj.run(-1, "conobj.new(22913):setParameter(\"lmp_t174_Farbe_FZ\", 1):doIt()")
vsobj.run(-1, "conobj.test()")

conobj = commonapi.rerequire("commonapi2.lineextradetails.constructionscript")
conobj.new(136100):setParameter("lmlp_t174_Farbe_FZ", 1):doIt()
commonapi.rerequire("commonapi2.lineextradetails.vehiclescript").run(-1, "conobj.test()")

--]]
local modelCacheIsEngine = {}

local function convertToModelId(modelIdOrName)
	local t = type(modelIdOrName)
	if (t == "number") then
		if (modelIdOrName > #api.res.modelRep.getAll()) then
			return -1
		end
		return modelIdOrName
	elseif (t == "string") then
		local modelId = api.res.modelRep.find("vehicle/"..modelIdOrName)
		if (modelId < 0) then
			return -1
		end
		return modelId
	end
	return -1
end

local function isEngine(modelId)
	if (modelCacheIsEngine[modelId] ~= nil) then
		return modelCacheIsEngine[modelId]
	end
	local model = api.res.modelRep.get(modelId)
	if (model.metadata ~= nil and model.metadata.railVehicle ~= nil) then
		local rv = model.metadata.railVehicle
		if (rv.engines ~= nil and #rv.engines > 0) then
			modelCacheIsEngine[modelId] = true
			return true
		end
	end

	modelCacheIsEngine[modelId] = false
	return false
end



local function traceback(errorstr)
	errorstr = string.gsub(errorstr, ".+lineextradetails[/\\]vehiclescript%.lua", "vehiclescript.lua")
	local lines = errorstr.."\nStacktrace:\n"
	local max = 10

	for i = 2, max do
		local info = debug.getinfo(i)
		if (info == nil) then
			break
		end
		local line = ""
		local source = info.short_src
		local name = info.name
		if (source ~= nil) then
			if (source == "[C]") then
				if (name == "xpcall") then
					break
				end
				if (name == "assert") then
					goto continuetraceback
				end
			end
			source = string.gsub(source, ".+[/\\]vehiclescript%.lua$", "vehiclescript.lua")
			line = line .. source
		end
		if (info.currentline ~= nil) then
			line = line .. ":" .. tostring(info.currentline)
		end
		if (name ~= nil) then
			line = line .. " in "..name
		end
		lines = lines..line.."\n"
::continuetraceback::
	end

	return lines
end

function vs.run(entityId, script, scriptid)
	local testmode = (entityId == -1)
	--local vsnew = vs.new(entityId)
	local luafn, err
	local env = {
		vs = vs.newEnv(testmode).new(entityId),
		conobj = conobj.newEnv(testmode),
		testmode = testmode
	}
	setmetatable(env, {__index=_G})

	local scriptidsrc = scriptid

	if (scriptidsrc == nil) then
		scriptidsrc = "commonapi-vehiclescript.run."..entityId
	end

	luafn, err = load(script, scriptidsrc,"t", env)
	if (luafn == nil) then
		print(err)
		return false, err
	end

	local ok, errfn = xpcall(luafn, traceback)
	if (ok == false) then
		print(errfn)
		return false, errfn
	end
	return true
end


function vs.newEnv(testmode)
	local o = {}
	local mt = {
		__index = vs,
	}
	setmetatable(o, mt)
	o.testmode = testmode
	o.new = function(nentityId)
		return vs._new(o, nentityId)
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "new",
	calling = "(int entityId) -> VehicleScriptObject",
	params = {
		{ "entityId", "integer", "entityId" },
	},
	ret = "new VehicleScriptObject",
	desc = "Creates a vehicle script object.\nNote: In line events, there is already a predefined variable \"vs\", you don't need to create one"
}
function vs.new(entityId)
	return vs._new(vs, entityId)
end

function vs._new(parent, entityId)
	local o = {}
	local mt = {
		__index = parent,
	}
	setmetatable(o, mt)
	o.new = function(nentityId)
		return vs._new(parent, nentityId)
	end
	o.testmode = (parent.testmode == true)
	o.entityId = entityId
	o.selected = false
	if (entityId == -1) then
		o._tv = nil
		o._tvv = {}
		o.testmode = true
		return o
	end
	o._tv = api.engine.getComponent(entityId, api.type.ComponentType.TRANSPORT_VEHICLE)
	o._tvv = hs.deepcopy(o._tv.transportVehicleConfig.vehicles)
	return o
end

vs._doc[#vs._doc+1] = {
	name = "count",
	desc = "count (selected) elements",
	params = {
		{ "self" }
	},
	ret = "integer"
}
function vs:count()
	if (self.selected == false) then
		return #self._tvv
	end
	return #self.selected
end


vs._doc[#vs._doc+1] = {
	name = "selectEngines",
	desc = "select engines in a train",
	params = {
		{ "self" }
	},
	ret = "new Selection"
}
function vs:selectEngines()
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	local tvv = self.selected or o._tvv

	for idx, vehicle in ipairs(tvv) do
		if (isEngine(vehicle.part.modelId) ) then
			o.selected[#o.selected+1] = vehicle
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "selectWagons",
	desc = "select wagons in a train",
	params = {
		{ "self" }
	},
	ret = "new Selection"
}
function vs:selectWagons()
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	local tvv = self.selected or o._tvv

	for idx, vehicle in ipairs(tvv) do
		if (isEngine(vehicle.part.modelId) == false ) then
			o.selected[#o.selected+1] = vehicle
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "select",
	desc = "select part in a train",
	params = {
		{ "self" },
		{ "index", "integer", "position to select" }
	},
	ret = "new Selection"
}
function vs:select(index)
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}

	local tvv = self.selected or o._tvv

	if (index < 0) then
		index = #tvv+index+1
	end
	if (index <= #tvv) then
		o.selected = {
			tvv[index]
		}
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "selectByModel",
	desc = "selects by Modelname",
	params = {
		{ "self" },
		{ "modelIdOrName", "string|integer", "model or id of model" }
	},
	ret = "new Selection"
}
function vs:selectByModel(modelIdOrName)
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	local tvv = self.selected or o._tvv
	local modelId = convertToModelId(modelIdOrName)
	if (modelId < 0) then
		return o
	end
	for idx, vehicle in ipairs(tvv) do
		if (vehicle.part.modelId == modelId) then
			o.selected[#o.selected+1] = vehicle
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "selectByModels",
	desc = "selects by Modelname",
	params = {
		{ "self" },
		{ "modelIdOrNames", "table[string|integer]", "a table of models" }
	},
	ret = "new Selection"
}
function vs:selectByModels(modelIdsOrNamesTable)
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	local tvv = self.selected or o._tvv
	local searchIds = {}
	for i, modelIdOrName in ipairs(modelIdsOrNamesTable) do
		local modelId = convertToModelId(modelIdOrName)
		if (modelId ~= -1) then
			searchIds[modelId] = true
		end
	end

	for idx, vehicle in ipairs(tvv) do
		if (searchIds[vehicle.part.modelId] == true) then
			o.selected[#o.selected+1] = vehicle
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "setColor",
	desc = "change (selected) vehicle color",
	params = {
		{ "self" },
		{ "color", "Table", "{ r, g, b }  float values 0.0 .. 1.0" },
		{ "h", "Optional[float]", "add random hue (0.0 .. 1.0)" },
		{ "s", "Optional[float]", "add random saturation (0.0 .. 1.0)" },
		{ "l", "Optional[float]", "add random lightness (0.0 .. 1.0)" }
	},
	ret = "self"
}
function vs:setColor(color, h, s, l)
	local tvv = self.selected or self._tvv
	assert(type(color) == "table", "color expects a table")
	if (h ~= nil or s ~= nil or l ~= nil) then
		local worldEntity = api.engine.util.getWorld()
		local gameTimeComp = api.engine.getComponent(worldEntity, api.type.ComponentType.GAME_TIME)
		math.randomseed(gameTimeComp.gameTime)
		for idx, vehicle in ipairs(tvv) do
			local hsl = _utils.rgbToHsl(color)
			if (h ~= nil) then
				hsl[1] = hsl[1] + math.random(0, h*100) / 100
			end
			if (s ~= nil) then
				hsl[2] = hsl[2] + math.random(0, s*100) / 100
			end
			if (l ~= nil) then
				hsl[3] = hsl[3] + math.random(0, l*100) / 100
			end
			local rgb = _utils.hslToRgb(hsl)
			vehicle.part.color.x = rgb[1]
			vehicle.part.color.y = rgb[2]
			vehicle.part.color.z = rgb[3]
		end
		return self
	end
	for idx, vehicle in ipairs(tvv) do
		local vcolor = vehicle.part.color
		vcolor.x = color[1]
		vcolor.y = color[2]
		vcolor.z = color[3]
	end
	return self
end


vs._doc[#vs._doc+1] = {
	name = "setReversed",
	desc = "change (selected) to reversed",
	params = {
		{ "self" },
		{ "b", "Boolean", "reversed flag" }
	},
	ret = "self"
}
function vs:setReversed(b)
	local tvv = self.selected or self._tvv
	for idx, vehicle in ipairs(tvv) do
		vehicle.part.reversed = (b == true)
	end
	return self
end

vs._doc[#vs._doc+1] = {
	name = "remove",
	desc = "remove selected vehicles",
	params = {
		{ "self" },
	},
	ret = "new Selection"
}
function vs:remove()
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	if (self.selected ~= false) then
		for i = 1, #self.selected do
			local remvehicle = self.selected[i]
			o.selected[#o.selected+1] = remvehicle
			for d = #self._tvv, 1, -1 do
				if (tostring(self._tvv[d]) == tostring(remvehicle)) then
					table.remove(self._tvv, d)
				end
			end
		end
	else
		self._tvv = {}
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "insertAt",
	params = {
		{ "self" },
		{ "index", "integer", "position to insert, negative integers count from the end of the current consist" }
	},
	ret = "self"
}
function vs:insertAt(index)
	if (self.selected == false) then
		return
	end
	self:remove()
	local newindex = index
	if (index < 0) then
		newindex = #self._tvv + index + 2
	end
	for i = 1, #self.selected do
		local addvehicle = self.selected[i]
		if (index > #self._tvv+1) then
			newindex = #self._tvv+1
		end
		table.insert(self._tvv, newindex, addvehicle)
		newindex = newindex + 1
	end
	return self
end

local function createModel(modelIdOrName)
	local modelId = convertToModelId(modelIdOrName)
	if (modelId < 0) then
		print("modelId not found: "..modelIdOrName)
		assert(modelId > -1, "modelId not found: "..modelIdOrName)
		return
	end

	local tvpart = api.type.TransportVehiclePart.new()
	local modelData = api.res.modelRep.get(modelId)
	if (modelData.metadata == nil) then
		return
	end
	if (modelData.metadata.transportVehicle == nil) then
		return
	end
	if (modelData.metadata.transportVehicle.compartments == nil) then
		return
	end
	local compartments = modelData.metadata.transportVehicle.compartments
	local loadConfig = {}
	local autoLoadConfig = {}
	for idx, compartment in ipairs(compartments) do
		loadConfig[#loadConfig+1] = 0
		autoLoadConfig[#autoLoadConfig+1] = 0
	end

	tvpart.part.modelId = modelId
	tvpart.part.loadConfig = loadConfig
	tvpart.autoLoadConfig = autoLoadConfig
	return tvpart
end

vs._doc[#vs._doc+1] = {
	name = "createModels",
	desc = "create and select new models",
	params = {
		{ "self" },
		{ "modelIdsOrNames", "Table[Strings]", "names of model (without vehicle/)" },
		{ "count", "Optional[int]", "how many times to repeat"},
	},
	ret = "new Selection",
}
function vs:createModels(modelIdsOrNames, count)
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	if (count == nil) then
		count = 1
	end
	for c = 1, count do
		for i, modelIdOrName in ipairs(modelIdsOrNames) do
			local tvpart = createModel(modelIdOrName)
			if (tvpart ~= nil) then
				o.selected[#o.selected + 1] = tvpart
			end
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "createModel",
	desc = "create and select new model",
	params = {
		{ "self" },
		{ "modelIdOrName", "String", "name of model (without vehicle/)" },
		{ "count", "Optional[int]", "how many times to repeat"},
	},
	ret = "new Selection",
}
function vs:createModel(modelIdOrName, count)
	--print("vs:createModel", modelIdOrName)
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}

	if (count == nil) then
		count = 1
	end
	for c = 1, count do
		local tvpart = createModel(modelIdOrName)
		if (tvpart ~= nil) then
			o.selected[#o.selected+1] = tvpart
		end
	end
	return o
end

function vs:debug(returnself)
	local debug
	if (self.selected ~= false) then
		debug = "Selected: "
		for i = 1, #self.selected do
			local p = self.selected[i]
			debug = debug .. tostring(i) .. ":"..p.part.modelId.. " (" .. tostring(p) .." )  "
		end
		debug = debug .. "\n"
	else
		debug = "Vehicle: "
		for i = 1, #self._tvv do
			local p = self._tvv[i]
			debug = debug .. tostring(i) .. ":"..p.part.modelId.. " (" .. tostring(p) .." )  "
		end
	end
	print(debug)
	if (returnself == true) then
		return self
	end
	return
end

vs._doc[#vs._doc+1] = {
	name = "shuffle",
	params = {
		{ "self" },
	},
	ret = "new Selection",
	desc = "shuffle selection",
}
function vs:shuffle()
	local o = {}
	setmetatable(o, {
		__index = self
	})
	o.selected = {}
	if (self.selected ~= false) then
		for i = 1, #self.selected do
			o.selected[i] = self.selected[i]
		end
	else
		for i = 1, #self._tvv do
			o.selected[i] = self._tvv[i]
		end
	end
	for i = #o.selected, 2, -1 do
		local j = math.random(i)
		o.selected[i], o.selected[j] = o.selected[j], o.selected[i]
	end

	local direct = true
	if (direct == true) then
		-- compare with tostring as tvparts are equal if modelid is equal
		local selindex = 1
		local selsize = #o.selected
		local idList = {}
		for i = 1, selsize do
			idList[i] = tostring(o.selected[i])
		end
		for i = 1, #self._tvv do
			local id = tostring(self._tvv[i])

			for s = 1, #idList do
				if (idList[s] == id) then
					self._tvv[i] = o.selected[selindex]
					selindex = selindex + 1
					if (selindex > selsize) then
						break
					end
				end
			end
			if (selindex > selsize) then
				break
			end
		end
	end
	return o
end

vs._doc[#vs._doc+1] = {
	name = "doIt",
	params = {
		{ "self" },
	},
	desc = "apply changes",
}
function vs:doIt()
	local tvc = api.type.TransportVehicleConfig.new()
	for i = 1, #self._tvv do
		tvc.vehicles[i] = self._tvv[i]
		tvc.vehicleGroups[i] = 1
	end
	if (self.testmode == true) then
		return
	end
	local cmd = api.cmd.make.replaceVehicle(self.entityId , tvc )
	api.cmd.sendCommand(cmd)
end

hs.createDoc(vs)
return vs