local ModListErrorWindow = {}

local _log = commonapi.utils.logPrep("commonapi2.ui.ModListErrorWindow")
local _utils = commonapi.utils
local _ = _utils._t
local ui = commonapi.ui;



local ModCommonListWindow = require("commonapi2.ui.ModCommonListWindow")

local errwin = ui.Window:new()

errwin.id = "ModListErrorWindow"
errwin.caption = _("Mod errors:")

-- called later by ModCommonListWindow genModMMDownloadLink
function errwin:clearCache()
	-- FIXME: we should tell TPF2 to refresh it's internal state somehow, but how?
	commonapi.mods._loadByFS()
	if (self:createUIList() ~= true) then
		self:close()
	end
end

function errwin:refresh()
	self:createUIList()
end

function errwin:createUIList()
--	local uilist = {}

	local uilist  = ModCommonListWindow.genModUIList(self)
	ModCommonListWindow.createErrorList(self, uilist)

	self.uilist = uilist
	if (#uilist > 0)  then
		return true
	end
	return false
end


local function savegamemodlistcallback(data, location)
	local mods = commonapi.mods
--[[
	print("savegamemodlistcallback")
	print(debug.traceback())
	print(commonapi._native.getLuaStatePtr())
	commonapi.dmp(data)
	commonapi.dmp(location)
--]]


	if (data == nil) then
		mods._reset()
		if (location == "CGame") then
			mods._shared_store()
		--	print("savegamemodlistcallback(data=nil): _shared_store done")
		end
		errwin:close()
		--print("savegamemodlistcallback(data=nil): errwin close done")

		local ModListWindow = ui.getWindow("ModListWindow")
		if (ModListWindow ~= nil) then
			ModListWindow:refresh()
		end

		--print("savegamemodlistcallback(data=nil): done")
		return
	end

	local sfn = function(a, b)
		return a.state < b.state
	end
	table.sort(data, sfn)

	mods._reset()
	for i, entry in ipairs(data) do
		if (entry.isMissing == true) then
			mods._addMissingModId(entry.id.."_"..entry.version, entry.name or nil, (entry.state < 0))
		else
			mods._addModByPathAndId(entry.path, entry.id.."_"..entry.version, (entry.state < 0) )
		end
	end
	if (location == "CGame") then
		mods._shared_store()
	end

	mods._checkMods()
	if (errwin:createUIList()) then
		errwin:open()
	else
		errwin:close()
	end


	local ModListWindow = ui.getWindow("ModListWindow")
	if (ModListWindow ~= nil) then
		ModListWindow:refresh()
	end
	--print("savegamemodlistcallback: done")
end

function ModListErrorWindow.run()
	commonapi._native.setModListCallbackFn(savegamemodlistcallback);
end

return ModListErrorWindow