local layerview = {}

local _utils = commonapi.utils
local _log = _utils.logPrep("commonapi.ui2.LayerView")

function layerview.init()
	if (commonapi._native ~= nil and commonapi._native.LayerView and commonapi._native.LayerView.isEnabled()) then
		layerview.changeLayerWin()

		layerview.changeWinManagar("lineManager", "lineManager.newLine")
		layerview.changeWinManagar("vehicleManager", "vehicleManager.buyVehicles")
	end
end

function layerview.disableLayer2()
	commonapi._native.LayerView.setLayer(2, 1)
	commonapi._native.LayerView.setLayer(2, 0)
end

function layerview.changeLayerWin()
	local speedLimitWindow
	local speedLimitWindowContent
	local speedLimitWindowLayout
	local speedLimitWindowLayoutTop
	local wButtonId = "commonapi2.layerview.speedLimitsWindowButton"
	local wButton = api.gui.util.getById(wButtonId)

	if (wButton == nil) then
		speedLimitWindow = api.gui.util.getById("menu.layers.speedLimitsWindow")
		--speedLimitWindowContent = speedLimitWindow:getContent()
		--speedLimitWindowLayout = speedLimitWindowContent:getLayout()

		speedLimitWindowLayoutTop = speedLimitWindow:getLayout():getItem(0):getLayout()

		wButton = layerview.createLayerChangeButton(wButtonId)

		wButton:setTooltip(_("Disable white layer").." (CommonAPI)")
		wButton:onClick(layerview.disableLayer2)
		wButton:addStyleClass("commonapi-layerview-off")

		local insertAt = speedLimitWindowLayoutTop:getNumItems()-2
		speedLimitWindowLayoutTop:insertItem(wButton, insertAt)
		--speedLimitWindowLayoutTop:addItem(wButton)
	end

end

function layerview.createLayerChangeButton(wButtonId)
	local wButton
	local tga = "ui/icons/windows/vehicle_color@2x.tga"
	local wButtonIcon = api.gui.comp.ImageView.new(tga)

	wButton = api.gui.comp.Button.new(wButtonIcon, true)
	wButton:setId(wButtonId)
	wButton:setGravity(0, 0.5)
	wButton:setMaximumSize( api.gui.util.Size.new(32, 32))
	return wButton
end


function layerview.onClickWinManagarOn()
	commonapi._native.LayerView.setManagerDisable(false)
	commonapi._native.LayerView.setLayer(2, 1)
end

function layerview.onClickWinManagarOff()
	commonapi._native.LayerView.setManagerDisable(true)
	commonapi._native.LayerView.setLayer(2, 0)
end

function layerview.changeWinManagar(manager, refId)
	local id = "commonapi2.layerview."..manager
	local wButtonOnId = id..".on";
	local wButtonOffId = id..".off";
	local wButtonOn
	local wButtonOff


	wButtonOn = api.gui.util.getById(wButtonOnId)
	if (wButtonOn ~= nil) then
		return
	end
	local child = api.gui.util.getById(refId)
	if (child == nil) then
		return
	end
	local win = commonapi.ui._getParentWindow(child)

	local topLayout = win:getLayout():getItem(0):getLayout()

	local insertAt = topLayout:getNumItems()-3
	wButtonOn = layerview.createLayerChangeButton(wButtonOnId)
	wButtonOn:addStyleClass("commonapi-layerview-on")
	wButtonOn:onClick(layerview.onClickWinManagarOn)
	wButtonOn:setTooltip(_("Enable white layer").." (CommonAPI)")
	topLayout:insertItem(wButtonOn, insertAt)

	insertAt = topLayout:getNumItems()-3
	wButtonOff = layerview.createLayerChangeButton(wButtonOffId)
	wButtonOff:addStyleClass("commonapi-layerview-off")
	wButtonOff:onClick(layerview.onClickWinManagarOff)
	wButtonOff:setTooltip(_("Disable white layer").." (CommonAPI)")
	topLayout:insertItem(wButtonOff, insertAt)
end


return layerview