local linedestui = {}

local _utils = commonapi.utils
local _log = _utils.logPrep("commonapi.ui2.LineDestination")
local _syncdata = commonapi._syncdata
local tpfui = commonapi.ui

-- print("Check translation system: >", commonapi.utils._t("Enable"), "<\n")


--  uielements = require("commonapi2.ui2.LineDestination").getImportantWindowElements()


-- LineManager = api.gui.util.getById("lineManager.newLine"):getParent()


-- LineManagerEditorComp = LineManager:getLayout():getItem(1)
-- LineManager_LineEditorComp = LineManager:getLayout():getItem(1)

-- LineEditor = LineManager_LineEditorComp:getLayout():getItem(0)

-- LineEditorStationsTable = LineEditor:getLayout():getItem(0):getItem(0):getItem(1)
-- supports deleteall


-- RemoveAllStation = LineEditor:getLayout():getItem(0):getItem(0):getItem(2):getItem(1)

-- LineEditor_Settings = LineEditor:getLayout():getItem(0):getItem(1)



-- LineDepotFilter = LineManager:getLayout():getItem(0):getItem(2)

-- LineDepotFilter

-- LineList = LineDepotFilter:getLayout():getItem(0)



-- LineName = LineList:getItem(0, 0):getLayout():getItem(0):getLayout():getItem(1):getText()
-- LineName  = commonapi.ui._findByName(LineList:getItem(0, 0), "LineButton::Text", 3)
local lineextradetails = require("commonapi2.lineextradetails.lineextradetails")



function linedestui.create()
	local uilements = linedestui.getImportantWindowElements()
	if (uilements == nil) then
		_log("getImportantWindowElements failed")
		return
	end
end

function linedestui.getImportantWindowElements()
	local LineManagerNewLine = api.gui.util.getById("lineManager.newLine")
	if (LineManagerNewLine == nil) then
		return nil
	end
	local LineManager = LineManagerNewLine:getParent()


	local LineManagerLayout = LineManager:getLayout()


	local LineDepotFilter = LineManagerLayout:getItem(0):getItem(2)
	if (LineDepotFilter:getName() ~= "LineDepotFilter") then
		print("LineDepotFilter not found")
		return nil
	end

	local LineList = LineDepotFilter:getLayout():getItem(0)
	if (LineList:getName() ~= "Table") then
		print("LineList not found")
		return nil
	end

	local LineManager_LineEditorComp = LineManager:getLayout():getItem(1)
	if (LineManager_LineEditorComp:getName() ~= "LineManager::LineEditorComp") then
		print("LineManager::LineEditorComp not found")
		return nil
	end

--[[ since build 35300 not working anymore
	local LineEditor = LineManager_LineEditorComp:getLayout():getItem(0)
	if (LineEditor:getName() ~= "LineEditor") then
		print("LineEditor not found")
		return nil
	end
--]]
	local LineEditor = tpfui._findByName( LineManager_LineEditorComp , "LineEditor", 2)
	if (LineEditor == nil) then
		print("LineEditor not found")
		return nil
	end
	--local LineEditorStationsTable = LineEditor:getLayout():getItem(0):getItem(0):getItem(1)

	-- Build 35126
	local LineEditorStationsTable = LineEditor:getLayout():getItem(0):getItem(0):getItem(2)

	if (LineEditorStationsTable:getName() ~= "Table") then
		print("LineEditorStationsTable not found")
		return nil
	end



	local LineEditorSettings = LineEditor:getLayout():getItem(0):getItem(1)
	if (LineEditorSettings:getName() ~= "LineEditor::Settings") then
		print("LineEditor::Settings not found")
		return nil
	end

	--local LineDestText = api.
	--local LayoutForSettings = LineEditorSettings:getLayout():getItem(1)
	local LineEditorSettingsLayout = LineEditorSettings:getLayout()

	if (LineEditorSettingsLayout == nil) then
		print("LineEditorSettingsLayout not found")
	end
	local LayoutForSettings = LineEditorSettingsLayout

	local eleLineDestInfo = api.gui.comp.TextView.new("<info>")
	tpfui.forceId(eleLineDestInfo, "LineDestinationInfo")
	eleLineDestInfo:setGravity(0, 0)
	--eleLineDestInfo:setMaximumSize( api.gui.util.Size.new(32, 32))
	eleLineDestInfo:setMaximumSize( api.gui.util.Size.new(170, 100))
	eleLineDestInfo:setMinimumSize( api.gui.util.Size.new(170, 20))
	LayoutForSettings:addItem(eleLineDestInfo)



	local eleLineDestCheckbox = api.gui.comp.CheckBox.new(  _utils._t("Line Destination"), "ui/design/components/checkbox_invalid@2x.tga", "ui/design/components/checkbox_valid@2x.tga")
		eleLineDestCheckbox:setMaximumSize( api.gui.util.Size.new(170, 100))
		eleLineDestCheckbox:setMinimumSize( api.gui.util.Size.new(170, 20))
		tpfui.forceId(eleLineDestCheckbox, "LineDestination_Checkbox")
		LayoutForSettings:addItem(eleLineDestCheckbox)

		local LineDestCheckboxToggleFn = function(checked)
			local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
			if (curSelf ~= nil) then
				local ok, err = pcall(curSelf.LineDestCheckboxChangeEvent)
				if (ok == false) then
					print(err)
				end
			end
		end
		eleLineDestCheckbox:onToggle(LineDestCheckboxToggleFn)
		eleLineDestCheckbox:setTooltip( _utils._t("Enable this stop as next destination display (vehicle need to support destination display)") )

	local eleLineDestText = api.gui.comp.TextInputField.new("")
		tpfui.forceId(eleLineDestText, "LineDestinationText")
		--eleLineDestText:setGravity(0, 0)
		local LineLineDestTextChangeFn = function()
			local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
			if (curSelf ~= nil) then
				local ok, err = pcall(curSelf.LineDestTextChangeEvent)
				if (ok == false) then
					print(err)
				end
			end
		end
		eleLineDestText:onEnter(LineLineDestTextChangeFn)
		eleLineDestText:setTooltip( _utils._t("Add custom line destination text, press <enter> to accept") )
		--LayoutForSettings:addItem(eleLineDestText)

	local eleLineDestTextScrollContent = api.gui.comp.Component.new("ScrollArea::Content")
	local eleLineDestTextScrollContentLayout = api.gui.layout.FloatingLayout.new()
	eleLineDestTextScrollContent:setLayout(eleLineDestTextScrollContentLayout)

	local eleLineDestTextScroll = api.gui.comp.ScrollArea.new(eleLineDestTextScrollContent, "LineDestTextScrollArea")
	tpfui.forceId(eleLineDestTextScroll, "LineDestinationTextScrollArea")
	--eleLineDestTextScroll:setHorizontalScrollBarPolicy(api.gui.comp.ScrollBarPolicy.ALWAYS_ON)
	LayoutForSettings:addItem(eleLineDestTextScroll)

	eleLineDestText:setGravity(-1,-1)
	eleLineDestTextScrollContentLayout:addItem(eleLineDestText, 0, 0)


	local enablelineevents = true
	local eleLineToLineStopSettingsButton
	local eleLineOnVehicleArrivedCaption
	if (commonapi.supports and commonapi.supports("LINE_EVENTS") and enablelineevents) then
		eleLineOnVehicleArrivedCaption = api.gui.comp.TextView.new( _utils._t("On vehicle arrived:") )
		tpfui.forceId( eleLineOnVehicleArrivedCaption, "LineDestination_OnVehicleArrivedCaption" )
		LayoutForSettings:addItem(eleLineOnVehicleArrivedCaption)

		local eleLineToLineStopSettingsButtonText = api.gui.comp.TextView.new( _utils._t("More Settings...") )
		eleLineToLineStopSettingsButtonText:setName("ConfigureButton::Text")
		eleLineToLineStopSettingsButton = api.gui.comp.Button.new(eleLineToLineStopSettingsButtonText, true)
		tpfui.forceId(eleLineToLineStopSettingsButton, "LineDestination_LineStopSettings")
		eleLineToLineStopSettingsButton:setName("ConfigureButton")
		local LineToVehicleModififerClickFn = function()
			local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
			if (curSelf ~= nil) then
				local ok, err = pcall(curSelf.LineToLineStopSettingsEvent)
				if (ok == false) then
					print(err)
				end
			end
		end
		eleLineToLineStopSettingsButton:onClick(LineToVehicleModififerClickFn)
		LayoutForSettings:addItem(eleLineToLineStopSettingsButton)
	end


		local eleLineToVehicleManagerText = api.gui.comp.TextView.new( _utils._t("Vehicles") )
		eleLineToVehicleManagerText:setName("ConfigureButton::Text")
		local eleLineToVehicleManager = api.gui.comp.Button.new(eleLineToVehicleManagerText, true)
		tpfui.forceId(eleLineToVehicleManager, "LineDestination_LineToVM")
		eleLineToVehicleManager:setName("ConfigureButton")
		local LineToVehicleManagerClickFn = function()
			local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
			if (curSelf ~= nil) then
				local ok, err = pcall(curSelf.LineToVehicleManagerEvent)
				if (ok == false) then
					print(err)
				end
			end
		end
		eleLineToVehicleManager:onClick(LineToVehicleManagerClickFn)
		eleLineToVehicleManagerText:setTooltip( _utils._t("Go to line vehicles").." (CommonAPI)")
		LayoutForSettings:addItem(eleLineToVehicleManager)

	local uielements = {
		LineList = LineList,
		LineEditorStationsTable = LineEditorStationsTable,

		--LineDestCaption = eleLineDest,
		LineDestInfo = eleLineDestInfo,
		LineDestCheckbox = eleLineDestCheckbox,
		LineDestText = eleLineDestText,
		LineOnVehicleArrivedCaption = eleLineOnVehicleArrivedCaption,
		LineToLineStopSettings = eleLineToLineStopSettingsButton,
		LineToVehicleManager = eleLineToVehicleManager
	}

	linedestui.uielements = uielements
	return uielements
end


function linedestui.LineToVehicleManagerEvent()
	local missingmsg = "linedestui.LineToVehicleManagerEvent missing element "
	local uielements = linedestui.uielements
	if (uielements == nil) then
		return
	end

	local lineEntityId, err = linedestui.findSelectedLineEntityId(uielements)

	if (lineEntityId == nil) then
		return
	end

	local lineNameComp = api.engine.getComponent(lineEntityId, api.type.ComponentType.NAME)
	if (lineNameComp == nil) then
		return
	end
	local lineName = lineNameComp.name
--	print("linename ",lineName)

	local VehicleManagerFilter = api.gui.util.getById("vehicleManager.buyVehicles"):getParent()
	local VehicleManagerFilterLayout = VehicleManagerFilter:getLayout()
	local VehicleManager = commonapi.ui._getParentWindow(VehicleManagerFilter)
	VehicleManager:setVisible(true, true)

	local CarrierFilterButtonAll = commonapi.ui._findByName(VehicleManagerFilterLayout, "CarrierFilterButton", 3)
	if (CarrierFilterButtonAll == nil) then
		print(missingmsg, "CarrierFilterButtonAll")
		return
	end

	if (CarrierFilterButtonAll.toggle ~= nil) then
		CarrierFilterButtonAll:toggle()
	end

	local LineDepotFilter = commonapi.ui._findByName(VehicleManagerFilterLayout, "LineDepotFilter", 3) --VehicleManagerFilterLayout:getItem(2)
	if (LineDepotFilter == nil) then
		print(missingmsg, "LineDepotFilter")
		return
	end
	local LineDepotFilterTable = commonapi.ui._findByName(LineDepotFilter, "Table", 1) -- LineDepotFilter:getLayout():getItem(1)

	if (LineDepotFilterTable == nil) then
		print(missingmsg, "LineDepotFilterTable")
		return
	end

	if (LineDepotFilterTable.getNumRows == nil) then
		print(missingmsg, "LineDepotFilterTable isn't a table")
		return
	end

	--LineDepotFilterTable:setId("LineDepotFilterTable")
	local ScrollArea = commonapi.ui._findByName(LineDepotFilterTable, "ScrollArea",2)
	local numRows = LineDepotFilterTable:getNumRows()
	local offsetY = 0;
	if (numRows > 0) then
		for i = 0, numRows-1 do
			local itemText = LineDepotFilterTable:getItem(i,1):getLayout():getItem(1)
			if (itemText:getText() == lineName) then
--				print("Trying to select", lineName, " at location ", i, offsetY)

				LineDepotFilterTable:select(i, true)

				local newy = offsetY;
				if (ScrollArea ~= nil) then
					ScrollArea:invokeLater(
						function()
							ScrollArea:invokeLater(
								function()
									local v = ScrollArea:getScrollOffset()
									v.y = -newy
									ScrollArea:setScrollOffset(v)
								end
							)
						end
					)
				end
			end
			offsetY = offsetY + LineDepotFilterTable:getRowHeight(i)
		end
	end

--	commonapi.ui.inspect(VehicleManager, "VehicleManagerWindow.txt")
-- api.gui.util.getById("vehicleManager.buyVehicles"):getParent():getParent():getParent():getParent():setId("")
end


function linedestui.LineStopListSelectEvent()
	--Simple update UI
	local ok, err = pcall(linedestui.updateUI)
	if (ok == false) then
		print(err)
	end
end

function linedestui.LineListSelectEvent()
	--Simple update UI
	local ok, err = pcall(linedestui.updateUI)
	if (ok == false) then
		print(err)
	end
end

function linedestui.LineToLineStopSettingsEvent()
	local ok, err = pcall(linedestui.openSettingsUI)
	if (ok == false) then
		print(err)
	end
end


function linedestui.LineDestCheckboxChangeEvent()
	local ok, err = pcall(linedestui.changeSelectedLineEntity, true)
	if (ok == false) then
		print(err)
	end
end

function linedestui.LineDestTextChangeEvent()
	local ok, err = pcall(linedestui.changeSelectedLineEntity, false)
	if (ok == false) then
		print(err)
	end
end

function linedestui.LineOnEmptyReturnToChangeEvent(event)
	local ok, err = pcall(linedestui.OnEmptyReturnToChangeEvent, event)
	if (ok == false) then
		print(err)
	end
end

function linedestui.OnEmptyReturnToChangeEvent(event)
	local stopData = linedestui.getSelectedLineStop()
	if (stopData == nil) then
		return true
	end

	if (event == 1) then
		lineextradetails.setOnEmptyVehicleData(stopData.lineId, stopData.uniqueId, {
			returnTo = 0
		})
	else
		lineextradetails.removeOnEmptyVehicleData(stopData.lineId, stopData.uniqueId)
	end
	linedestui.updateUI()
end

function linedestui.changeSelectedLineEntity(isCheckboxEvent)
	local uielements = linedestui.uielements or linedestui.getImportantWindowElements()
	if (uielements == nil) then
		return true
	end

	local stopData = linedestui.getSelectedLineStop()
	if (stopData == nil) then
		return true
	end

	local text = uielements.LineDestText:getText()
	uielements.LineDestText:getText()

	local checkBoxSel = uielements.LineDestCheckbox:isSelected()

	if (checkBoxSel == true or (text ~= "" and isCheckboxEvent ~= true) ) then
		lineextradetails.setEndStationData(stopData.lineId, stopData.uniqueId, {
			caption = text
		})
	else
		_log("Remove endStations",stopData.uniqueId)
		lineextradetails.removeEndStationData(stopData.lineId, stopData.uniqueId)
	end
	-- upgrades indicators:
	linedestui.updateUI()
	return true
end

function linedestui.openSettingsUI()
	local uielements = linedestui.uielements or linedestui.getImportantWindowElements()
	if (uielements == nil) then
		_log("uielements empty")
		return true
	end
	local lineEntityId, stopData, err = linedestui.getSelectedLineEntityAndStop(uielements)
	if (lineEntityId == nil or stopData == nil or stopData.waypoint == true) then
		return true
	end

	package.loaded["commonapi2.ui2.LineStopSettings"] = nil
	local ok, LineStopSettings = pcall(require,  "commonapi2.ui2.LineStopSettings")
	if ok then
		LineStopSettings.create(stopData.lineId, stopData.uniqueId, stopData)
	else
		print(LineStopSettings)
	end
	return true
end



function linedestui.updateUI()
	local uielements = linedestui.uielements or linedestui.getImportantWindowElements()
	if (uielements == nil) then
		_log("uielements empty")
		return true
	end
	local lineEntityId, stopData, err = linedestui.getSelectedLineEntityAndStop(uielements)
	if (lineEntityId == nil or stopData == nil or stopData.waypoint == true) then
		local lineDestInfoText = ""
		if (type(err) == "string") then
			lineDestInfoText = err
		else
			if (stopData ~= nil and stopData.waypoint == true) then
				lineDestInfoText = _utils._t("Waypoint, please select normal Stop")
			end
		end
		uielements.LineDestInfo:setText(lineDestInfoText)
		uielements.LineDestInfo:setVisible(true, false)

		uielements.LineDestCheckbox:setVisible(false, false)
		uielements.LineDestCheckbox:setEnabled(false)
		uielements.LineDestCheckbox:setSelected(false, false)

		uielements.LineDestText:setVisible(false, false)
		uielements.LineDestText:setEnabled(false)
		uielements.LineDestText:setText("", false)

		if (uielements.LineOnVehicleArrivedCaption) then
			uielements.LineOnVehicleArrivedCaption:setVisible(false, false)
		end
		if (uielements.LineToLineStopSettings) then
			uielements.LineToLineStopSettings:setVisible(false, false)
		end
	else
		local destinationData = lineextradetails.getEndStationData(lineEntityId, stopData.uniqueId) or {}
		uielements.LineDestInfo:setVisible(false, false)
		uielements.LineDestInfo:setText(stopData.lineId.." "..stopData.uniqueId)

		uielements.LineDestCheckbox:setVisible(true, false)
		uielements.LineDestCheckbox:setEnabled(true)
		uielements.LineDestCheckbox:setSelected(destinationData.caption ~= nil, false)

		uielements.LineDestText:setVisible(true, false)
		uielements.LineDestText:setEnabled(true)
		uielements.LineDestText:setText(destinationData.caption or "", false)

		if (uielements.LineOnVehicleArrivedCaption) then
			uielements.LineOnVehicleArrivedCaption:setVisible(true, false)
		end
		if (uielements.LineToLineStopSettings) then
			uielements.LineToLineStopSettings:setVisible(true, false)
		end
	end
	if (lineEntityId ~= nil) then
		linedestui.updateIndicators(lineEntityId)
	end
	return true
end

function linedestui.updateIndicators(lineEntityId)
	if (linedestui.uielements == nil) then
		return
	end
	local LineEditorStationsTable = linedestui.uielements.LineEditorStationsTable
	local endStations = lineextradetails.getEndStations(lineEntityId) or {}
	local vehicleArrived = lineextradetails.getOnVehicleArrivedAll(lineEntityId) or {}
	local vehicleNextStop = lineextradetails.getOnVehicleNextStopAll(lineEntityId) or {}

	local setStylesFn = function(ele, uniqueId, table, feature, styleclass)
		if (table ~= nil and table[uniqueId] ~= nil and table[uniqueId][feature]) then
			ele:addStyleClass(styleclass)
		else
			ele:removeStyleClass(styleclass)
		end
	end
	local patchStopCounterFn = function(counter, entityId, entityIdIdx, uniqueId)
		if (counter >= LineEditorStationsTable:getNumRows()) then
			return
		end
		local LineFilterItemLineComp = LineEditorStationsTable:getItem(counter, 1)
		if (LineFilterItemLineComp == nil) then
			return
		end

		local Layout = LineFilterItemLineComp:getLayout():getItem(0):getLayout()
		if (Layout == nil) then
			return
		end
		local LineDestIndicators = tpfui._findByName( Layout , "LineDestIndicators", 2)
		if (LineDestIndicators == nil) then

			LineDestIndicators = api.gui.comp.Component.new("LineDestIndicators")
			local LineDestIndicatorsLayout = api.gui.layout.BoxLayout.new("HORIZONTAL")
			LineDestIndicators:setLayout(LineDestIndicatorsLayout)
			local LineDestIndicators2 = api.gui.comp.Component.new("LineDestIndicators2")
			LineDestIndicatorsLayout:addItem(LineDestIndicators2)

			--LineDestIndicators2 = api.gui.comp.Component.new("LineDestIndicatorsSecond")
			--commonapi.dmp(LineDestIndicators:getL)
			--LineDestIndicators:setMinimumSize(api.gui.util.Size.new(19, 19))
			--LineDestIndicators:setGravity(0, 0.5)
			Layout:insertItem(LineDestIndicators, 0)
		--	Layout:addItem(LineDestIndicators)
		end

		if (LineDestIndicators.addStyleClass) then
			setStylesFn(LineDestIndicators, uniqueId, endStations, "caption", "linestop-linedestination")
			setStylesFn(LineDestIndicators, uniqueId, vehicleArrived, "runScript", "linestop-vehiclearrived-script")
			setStylesFn(LineDestIndicators, uniqueId, vehicleNextStop, "runScript", "linestop-vehiclenextstop-script")
			setStylesFn(LineDestIndicators, uniqueId, vehicleNextStop, "ifEmptyReturnTo", "linestop-vehiclenextstop-returnto")
		end

	end

	local listOfStops = lineextradetails.getLineStops(lineEntityId, true) or {}
	for index, stopData in ipairs(listOfStops) do
		patchStopCounterFn(index-1, stopData.id, stopData.idx, stopData.uniqueId)
	end
end



function linedestui.updateIndicators2(lineEntityId)
	if (linedestui.uielements == nil) then
		return
	end
	local LineEditorStationsTable = linedestui.uielements.LineEditorStationsTable
	local endStations = lineextradetails.getEndStations(lineEntityId) or {}
	local vehicleArrived = lineextradetails.getOnVehicleArrivedAll(lineEntityId) or {}

	local patchStopCounterFn = function(counter, entityId, entityIdIdx, uniqueId)
		if (counter >= LineEditorStationsTable:getNumRows()) then
			return
		end
		local TableItem = LineEditorStationsTable:getItem(counter, 0)
		if (TableItem == nil) then
			return
		end

		local StopCounterLabelLayout = TableItem:getLayout()
		if (StopCounterLabelLayout == nil) then
			return
		end

		local StopCounterLabel = StopCounterLabelLayout:getItem(0)
		if (StopCounterLabel == nil) then
			return
		end
		local styleclass = "linestop-linedestination" --"big-error-message"

		if ( endStations[ uniqueId ] ~= nil or vehicleArrived[ uniqueId ] ~= nil) then
			if (StopCounterLabel.addStyleClass) then
				StopCounterLabel:addStyleClass(styleclass)
			end
		else
			if (StopCounterLabel.removeStyleClass) then
				StopCounterLabel:removeStyleClass(styleclass)
			end
		end
	end

	local listOfStops = lineextradetails.getLineStops(lineEntityId, true) or {}
	for index, stopData in ipairs(listOfStops) do
		--commonapi.dmp(stopData)
		patchStopCounterFn(index-1, stopData.id, stopData.idx, stopData.uniqueId)
	end
end


function linedestui.getLineFilterItem_ButtonComp(LineListItemLayout)
	local ButtonComp = LineListItemLayout:getItem(2)
	if (ButtonComp == nil or ButtonComp.getName == nil or ButtonComp:getName() ~= "LineFilterItem::ButtonComp") then
		return nil
	end
	return ButtonComp
end



function linedestui.getLineNameSelectedFromLineList(uielements)
	local LineList = uielements.LineList
	local LineListCurSelected = LineList:getSelected()
	local index = LineListCurSelected[1]
	if (index == nil) then
		local err = " index missing!"
		return nil, err
	end
	local LineListItem = LineList:getItem(index, 0)
	if (LineListItem == nil) then
		local err = " LineListItem missing!"
		return nil, err
	end

	local LineButtonText = commonapi.ui._findByName(LineListItem, "LineButton::Text", 3)
	if (LineButtonText == nil) then
		local err = " LineButton::Text missing!"
		return nil, err
	end
	local lineName = LineButtonText:getText()
--	print("index: ", index, " lineName:", lineName)
--	commonapi.dmp(LineListCurSelected)
	return lineName
end

function linedestui.findSelectedLineEntityId(uielements)
	local lineNameSelected, err

	lineNameSelected, err = linedestui.getLineNameSelectedFromLineList(uielements)

	if (lineNameSelected == nil and err ~= nil) then
		return nil, err
	end
	local lineEntityId = nil

	if (lineNameSelected ~= nil) then
		local lineIds = api.engine.system.lineSystem.getLines()
		for i = 1, #lineIds do
			local lineNameComp = api.engine.getComponent(lineIds[i], api.type.ComponentType.NAME)
			if (lineNameComp.name == lineNameSelected) then
				if (lineEntityId ~= nil) then
					err = _utils._t("Duplicate Line Name found!")
					return nil, err
				else
					lineEntityId = lineIds[i]
				end
			end
		end
	end
	if (lineEntityId == nil) then
		err =  _utils._t("No line & stop selected")
		return nil, err
	end

	local lineComp = api.engine.getComponent(lineEntityId, api.type.ComponentType.LINE)

	if (lineComp == nil) then
		local err = "api.type.ComponentType.LINE for "..lineEntityId.." missing!"
		return nil, err
	end
--	print("lineEntityId selected:", lineEntityId)
	return lineEntityId, nil
end

function linedestui.getSelectedLineStop()
	local uielements = linedestui.uielements or linedestui.getImportantWindowElements()
	if (uielements == nil) then
		return nil, "linedestui.uielements nil"
	end

	local lineEntityId, stopData, err = linedestui.getSelectedLineEntityAndStop(uielements)
	return stopData, err
end

function linedestui.getSelectedLineEntity()
	local uielements = linedestui.uielements or linedestui.getImportantWindowElements()
	if (uielements == nil) then
		return nil, "linedestui.uielements nil"
	end
	local lineEntityId, err
	lineEntityId, err = linedestui.findSelectedLineEntityId(uielements)
	if (lineEntityId == nil) then
		return lineEntityId, err
	end
	return lineEntityId, nil
end

function linedestui.getSelectedLineEntityAndStop(uielements)
	local LineEditorStationsTable = uielements.LineEditorStationsTable

	local lineEntityId, err
	lineEntityId, err = linedestui.findSelectedLineEntityId(uielements)
	if (lineEntityId == nil) then
		return lineEntityId, nil, err
	end

	local possibleStopIndex = LineEditorStationsTable:getSelected()[1]
	if (possibleStopIndex == nil) then
		local err = _utils._t("Select a stop!")
		return lineEntityId, nil, err
	end

	local listOfStops = lineextradetails.getLineStops(lineEntityId, true) or {}
	local stopData = listOfStops[possibleStopIndex+1]

--[[	if (stopData ~= nil and stopData.waypoint == true)  then
		local err = _utils._t("Waypoint not supported")
		return nil, err
	end
--]]
--	print("StopSelected:\n")
--	commonapi.dmp(stopData)

	return lineEntityId, stopData, nil
end



function linedestui.installHooks()
	local LineManagerNewLine = api.gui.util.getById("lineManager.newLine")

	if (LineManagerNewLine == nil) then
		_log("lineManager.newLine not found")
		return
	end

	_log("Preparing Hooks for LineDestination")

	local uilements = linedestui.getImportantWindowElements()
	if (uilements == nil) then
		_log("getImportantWindowElements failed")
		return
	end

	local LineList = uilements.LineList
	local LineListSelectFn = function(index)
		local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
		if (curSelf ~= nil) then
			pcall(curSelf.LineListSelectEvent, index)
		end
	end
	LineList:onSelect(LineListSelectFn)

	local LineEditorStationsTable = uilements.LineEditorStationsTable
	local LineEditorStationsTableSelectFn = function(index)
		local curSelf = package.loaded["commonapi2.ui2.LineDestination"]
		if (curSelf ~= nil) then
			pcall(curSelf.LineStopListSelectEvent, index)
		end
	end
	LineEditorStationsTable:onSelect(LineEditorStationsTableSelectFn)
	_log("Preparing Hooks for LineDestination: OK")
end

linedestui.create()
return linedestui