local console = {}

local _utils = commonapi.utils
local _log = _utils.logPrep("commonapi.ui2.console")
local ui = require("commonapi2.ui2.tpfui")


local function runConsoleWindow()
	local luafn, err, ok
	local filename = commonapi._info.path.."/doit.lua"
	luafn, err = loadfile(filename, "bt")
	if (luafn == nil) then
		if (errIfMissing) then
			print(filename..": file not found")
		end
	end

	ok, err = pcall(luafn)
	if (ok == false) then
		print(err)
	end
end
--[[
local consoleWin = {}
local consoleWinMeta = {
	__index = {
		open = function(self)
			if self.window ~= nil then
				return
			end
			self:_create()
		end,
		close = function(self)
			if self.window == nil then
				return
			end
			self.window:close()
		end,
		_destroy = function(self)
			console.close = function()
				consoleWin:close()
			endself.window = nil
			self.textView = nil
			self.imageView = nil
			self.boxLayout = nil
		end,
		_create = function(self)
			local s = "commonapi.console."
			--self.imageView = gui.imageView_create("contexthelper.imageView", getImage())
			self.textView = gui.textView_create(s .. "textView", "debug", 1000)
			self.doButton_Text = gui.textView_create(s .. "doButton_Text" , "DoIt!")
			self.doButton = gui.button_create(s .. "doButton", self.doButton_Text)
			self.doButton:onClick(function()
				runConsoleWindow()
--[[
				commonapi.dmp(_G)
				print("Current commonapitest", commonapitest.num)
				commonapitest.num = commonapitest.num + 100
				print("New commonapitest", commonapitest.num)
---
 			end)

			self.boxLayout = gui.boxLayout_create(s .. "boxLayout", "AUTO")

			--self.boxLayout:addItem(self.imageView)
			self.boxLayout:addItem(self.textView)

			

			self.boxLayout:addItem(self.doButton)

			self.something = gui.component_create("sampleX", "ScrollArea")

			self.boxLayout:addItem(self.something)


			self.window = gui.window_create(s .. "window", "CommonAPI console", self.boxLayout)
			self.window:onClose(function ()
				self:_destroy()
			end)
		end
	}
}
setmetatable(consoleWin, consoleWinMeta)

--]]
console.baseId = "commonapi2consoleAddon."
console.curstate = "UG Console State"
local x = 1


function console.uiRunText_change(newvalue)
	print("uiRunText_change", newvalue)
end

function console.uiRunText_onEnter()
	if (console.curstate ~= nil) then
		commonapi._native.LuaStates.runString(console.curstate, console.uiRunText:getText())
	end
end

function console.uiComboBoxStates_ItemFactory()
	print( "console.uiComboBoxStates_ItemFactory() ")
	local s = api.gui.util.getById(console.baseId.."ComboBox")
--	s:clear(true)
	local allstates = commonapi._native.LuaStates.getAll()

	for i, info in ipairs(allstates) do
		s:addItem(info.name)
	end
	s:addItem("Hallo "..x)

	local ele = api.gui.comp.TextView.new("Last Item"..x)
	x = x + 1
	return ele
end


local popupList = {}

function popupList.new(caption)
	local o = {
		_open = false,
		_items = {}
	}
	local meta = {
		__index = popupList
	}
	setmetatable(o, meta)
	o.eleCaption = api.gui.comp.TextView.new(caption or "popupList")
	o.eleLayout = api.gui.layout.BoxLayout.new("VERTICAL")
	o.ele = api.gui.comp.Component.new("commonapi2_popuplist")
	o.ele:setLayout(o.eleLayout)



	local tga = "ui/combobox_arrows.tga"
	local eleCaptionIcon = api.gui.comp.ImageView.new(tga)
	eleCaptionIcon:setMaximumSize( api.gui.util.Size.new(32, 32))

	local eleCaptionContainer = api.gui.comp.Component.new("commonapi2_popuplistcaption")
	local eleCaptionContainerLayout = api.gui.layout.BoxLayout.new("HORIZONTAL")
	eleCaptionContainer:setLayout(eleCaptionContainerLayout)

	eleCaptionContainerLayout:addItem(o.eleCaption)
	eleCaptionContainerLayout:addItem(eleCaptionIcon)
	o.eleButton = api.gui.comp.Button.new(eleCaptionContainer, true)

	--o.eleButton = api.gui.comp.Button.new(o.eleCaption, true)
	o.eleButton:onClick(function() o._onButtonHandler(o); end)

--[[
	local tga = "ui/icons/windows/vehicle_color@2x.tga"
	local wButtonIcon = api.gui.comp.ImageView.new(tga)
	wButtonIcon:setMaximumSize( api.gui.util.Size.new(32, 32))
	o.eleButton:getLayout():addItem(wButtonIcon, 1, 0)
	--o.eleButton:getLayout():setAlignment()
--]]

	o.eleLayout:addItem(o.eleButton)

	o.eleListContainerLayout = api.gui.layout.BoxLayout.new("VERTICAL")

	o.eleListContainer = api.gui.comp.Component.new("Popup")
	o.eleListContainer:setLayout(o.eleListContainerLayout)
	o.eleListContainer:setGravity(0, 0)
	o.eleListContainer:setVisible(false, false)

	o.eleList = api.gui.comp.List.new(false, 1, true)
	o.eleList:onSelect(function(newindex) o._onListChangeHandler(o, newindex); end)

	o.eleList:setGravity(0, 0)
	o.eleListContainerLayout:addItem(o.eleList)

	o.eleLayout:addItem(o.eleListContainer)


	o.eleList:onStep( function() o._onListLostFocus(o); end)
	return o, o.ele
end

function popupList:clear()
	self._items = {}
	self.eleList:clear(false)
end

function popupList:onOpen(fn)
	self._onopen = fn
end

function popupList:onChange(fn)
	self._onchange = fn
end


function popupList:setCaption(name)
	self.eleCaption:setText(name)
end

function popupList:getCaption(name)
	self.eleCaption:getText()
end


function popupList:_onListLostFocus()
	if (self._open ~= true) then
		return
	end

	if (self.eleList and self.eleList:hasFocus() == false) then
		self._open = false
		self:_handleTransition()
	end
end

function popupList:_handleTransition()
	local eleListContainer = self.eleListContainer
	if (eleListContainer == nil) then
		return
	end
	local eleRoot = commonapi.ui._getRoot()
	local absLayout = eleRoot:getLayout():getItem(1)

	--eleListContainer:getParent():getLayout():removeItem(eleListContainer)
	if (eleListContainer:getParent():getName() == "wrap") then
		absLayout:removeItem(eleListContainer)
	else
		self.eleLayout:removeItem(eleListContainer)
	end

	if (self._open == true) then
		self.eleList:setFocus()

		local rect1 = self.ele:getContentRect()
		local rectSelf = self.eleListContainer:getContentRect()
		rectSelf.x = rect1.x
		rectSelf.y = rect1.y+rect1.h
		absLayout:addItem(eleListContainer, rectSelf)
	else
		self.eleLayout:addItem(eleListContainer)
	end
	self.eleListContainer:setVisible(self._open, false)
end

function popupList:_onListChangeHandler(newindex)
	if (self._onchange ~= nil) then
		self:_onchange(newindex)
	end
	self._open = false
	self:_handleTransition()
end

function popupList:_onButtonHandler()
	if (self._onopen ~= nil) then
		if (self._open == false) then
			self:_onopen()
		end
	end
	self._open = not self._open
	self:_handleTransition()
end

function popupList:addItem(name, data)
	self._items[#self._items+1] = {
		name, data
	}
	local listItem = api.gui.comp.TextView.new(name)
	listItem:setGravity(-1, 0)
	self.eleList:addItem(listItem)

end


function popupList:getItem(index)
	return self.eleList:getItem(index)
end

function popupList:select(index, emitSignal)
	return self.eleList:select(index, emitSignal)
end

function popupList:getItemData(index)
	if (index >= 0) then
		return self._items[index+1] or nil
	end
	return  nil
end

function popupList:getSelectedIndex()
	return self.eleList:getSelectedIndex()
end

function popupList:getNumItems()
	return self.eleList:getNumItems()
end



function console.stateChanger_onOpen(s)
	local allstates = commonapi._native.LuaStates.getAll()
	s:clear()
	for i, info in ipairs(allstates) do
		s:addItem(info.name)
	end
end



function console.stateChanger_onChange(s, newindex)
	print( "stateChanger_onChange", newindex)

	if (newindex >= 0) then
		local data = s:getItemData(newindex)
		if (data) then
			print("New State = ", data[1])
			s:setCaption(data[1])
			console.curstate = data[1]
		end
	end
end


function console.init()
	if (commonapi._native == nil) then
		return
	end
	local ugwin = api.gui.util.getById("inGameConsole")
	if (ugwin == nil) then
		return
	end

	local layoutWin = ugwin:getLayout()
	--local runButton = gui.button_create(s .. "doButton", self.doButton_Text)

	local layoutContainer = api.gui.comp.Component.new("commonapi2_layouth")
	local layout = api.gui.layout.BoxLayout.new("HORIZONTAL")
	layoutWin:addItem(layoutContainer)
	layoutContainer:setLayout(layout)
	layoutContainer:setId(console.baseId.."HLayout")
	console.uiLayoutContainer = layoutContainer

	-- x = require("commonapi2.ui2.console")

	local stateChanger, stateChangerEle = popupList.new(console.curstate or "Select State")

	console.stateChanger = stateChanger
	stateChanger:onOpen( console.stateChanger_onOpen)
	stateChanger:onChange( console.stateChanger_onChange )
	stateChanger:addItem("Should not see me")

	layout:addItem(stateChangerEle)

	local runText = api.gui.comp.TextInputField.new("")
	runText:setGravity(-1, 0)
	runText:onChange(console.uiRunText_change)
	runText:onEnter(console.uiRunText_onEnter)
	layout:addItem(runText)

	console.uiRunText = runText


	--commonapi.ui.inspect("inGameConsole")
	rawset(_G, "consoleAddon", console)
end


function console.runGC(id)
	local ele = api.gui.util.getById(console.baseId..id)
	if (ele ~= nil) then
		print("Console.runGC: "..console.baseId..id)
		local parent = ele:getParent()
		local layout = parent:getLayout()
		layout:removeItem(ele)
		ele:destroy()
	end
end

local meta = {
	__gc = function(self)
		if (api and api.gui and api.gui.util) then
			print("Console run gc")
			console.runGC("HLayout")
			print("Console run gc end")
		end
	end
}
setmetatable(console, meta)
return console