local UIEvent = {}

function UIEvent.createClick(obj, item)
	if (item.onclick == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.onclick, item
	}
end

function UIEvent.createDblClick(obj, item)
	if (item.ondblclick == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.ondblclick, item
	}
end


function UIEvent.createChange(obj, item)
	if (item.onchange == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.onchange, item
	}
end


function UIEvent.createClose(obj, item)
	if (item.onclose == nil) then
		return
	end
	if (obj._events == nil) then
		obj._events = {}
	end
	obj._events[#obj._events+1] = {
		item.onclose, item
	}
end

function UIEvent.fireEvents(obj)
	local events = obj._events
	if (events ~= nil and #events > 0) then
		obj._events = {}
		for i, event in ipairs(events) do
			local fn = event[1]
			fn(event[2], obj)
		end
	end
end






return UIEvent